import axios from 'axios';

export default {
  namespaced: true,
  state: {
    property: null,
    propertyImages: [],
    propertyTypes: [],
    propertyOverviewFields: [],
    propertyFields: [],
  },
  mutations: {
    setProperty(state, property) {
      state.property = property;
    },
    setPropertyImages(state, images) {
      state.propertyImages = images;
    },
    setPropertyTypes(state, types) {
      state.propertyTypes = types;
    },
    setPropertyOverviewFields(state, fields) {
      state.propertyOverviewFields = fields;
    },
    setPropertyFields(state, fields) {
      state.propertyFields = fields;
    },
    updateCurrentProperty(state, property) {
      state.property = property;
    },
  },
  getters: {},
  actions: {
    getProperty({ commit }, item) {
      axios
        .get(`http://localhost:57260/Property/Property/${item.id}`)
        .then(result => commit('setProperty', result.data))
        .catch(console.error);
    },
    getPropertyImages({ commit }, item) {
      axios
        .get(`http://localhost:57260/property/PropertyImage/getpropertyimages/${item.id}`)
        .then(result => commit('setPropertyImages', result.data))
        .catch(console.error);
    },
    getPropertyTypes({ commit }, item) {
      axios
        .get(`http://localhost:57260/Property/PropertyType/type/${item.propertyType}`)
        .then(result => commit('setPropertyTypes', result.data))
        .catch(console.error);
    },
    getPropertyOverviewFields({ commit }) {
      axios
        .get('http://localhost:57260/Property/PropertyFields/Property Overview')
        .then(response => commit('setPropertyOverviewFields', response.data));
    },
    getPropertyFields({ commit }, item) {
      axios
        .get(`http://localhost:57260/property/propertyfields/Propertytype/${item.propertyType}`)
        .then(response => commit('setPropertyFields', response.data));
    },
    saveProperty({ commit }, item) {
      axios
        .post('http://localhost:57260/Property/Property', item.newProperty)
        .then(result => commit('updateCurrentProperty', result.data))
        .catch(console.error);
    },
  },
};
